/*  Subject line Edit Script for PMMail - Copyright 1999, John & Chris Angelico  */
/*   to trim out Re: and Fwd: for sorting/storing by threads                     */
/*  Put this into the PMMAIL directory and use the Utilities Settings REXX tab   */
/*     to invoke this as a Message Receive Exit                                  */
/*  This uses only standard REXX Functions available with Warp 3 or 4            */
/*                 plus RexxLib                                                  */
/*  Released to the PMMail community for the benefit of all                      */
/*  Take it as it is. Do what you like with it.                                  */
/*  But don't blame us if it does any damage!!                                   */
/*  New version Aug 21, 2000 using RexxLib instead of RxExtras                   */
/*                                                                               */

/* Initialisation routines */

Parse Arg targetfile
signal on syntax

/* Load the REXXUtil functions disabled
CALL RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
CALL SysLoadFuncs
*/

/* Check for path name of message file */
targetfile=stream(targetfile,"c","query exists")
if targetfile="" then exit

/* List of junk to trim from Subject line */ 
trim="~RE:~FWD:~(FWD)~[FWD]~FW:~"

/* Main processing routine: read file, trim junk then write out again */
data=charin(targetfile,,chars(targetfile))
call stream targetfile,"c","close"
p=pos("SUBJECT:",TRANSLATE(data))
before=left(data,p+7)
parse value substr(data,p+9) with subj"0d0a"x after
subj=space(subj)
newsubj=""
do j=1 to words(subj)
	if pos("~"translate(word(subj,j))"~",trim)=0 then newsubj=newsubj word(subj,j)
end

data=before||newsubj"0d0a"x||after

"@type nul >"targetfile
call charout targetfile,data
exit

syntax:

/* Error handling routine - interactive */
msg="Error "rc" - "errortext(rc)
say msg
call lineout "c:\desktop\errs.log",msg
msg="Line "sigl" - "sourceline(sigl)
say msg
call lineout "c:\desktop\errs.log",msg
trace ?i
nop
exit
