/*  Subject line Edit Script for PMMail - Copyright 1999, John & Chris Angelico  */
/*   to trim out Re: and Fwd: for sorting/storing by threads                     */
/*  Put this into the PMMAIL directory and use the Utilities Settings REXX tab   */
/*     to invoke this as a Message Receive Exit                                  */
/*  This uses only standard REXX Functions available with Warp 3 or 4            */
/*                 plus RexxLib                                                  */
/*  Released to the PMMail community for the benefit of all                      */
/*  Take it as it is. Do what you like with it.                                  */
/*  But don't blame us if it does any damage!!                                   */
/*  New version Aug 21, 2000 using RexxLib instead of RxExtras                   */
/*                                                                               */

/* Initialisation routines */

Parse Arg targetfile
signal on syntax

/* Load the REXXUtil functions disabled
CALL RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
CALL SysLoadFuncs
CALL RxFuncAdd 'REXXLIBREGISTER', 'REXXLIB', 'REXXLIBREGISTER'
CALL REXXLIBREGISTER
*/

/* Check for path name of message file */
targetfile=stream(targetfile,"c","query exists")
if targetfile="" then exit

/* List of junk to trim from Subject line */ 
trim.0=5
trim.1="RE:"
trim.2="FWD:"
trim.3="(FWD)"
trim.4="[FWD]"
trim.5="FW:"


/* Main processing routine: read file into stem, trim junk then write file out again */
call FILEREAD targetfile,"STEM"
do i=1 to stem.0
	if abbrev(translate(stem.i),"SUBJECT:") then do
		stem.i=space(stem.i)
		out=""
		do j=1 to words(stem.i)
			do k=1 to trim.0
				if translate(word(stem.i,j))=trim.k then leave
			end
			if k>trim.0 then out=out word(stem.i,j)
		end
		say stem.i
		stem.i=strip(out)
		say stem.i
	end
end
call filewrite targetfile,"STEM"
exit

syntax:

/* Error handling routine - interactive */
msg="Error "rc" - "errortext(rc)
say msg
call lineout "c:\desktop\errs.log",msg
msg="Line "sigl" - "sourceline(sigl)
say msg
call lineout "c:\desktop\errs.log",msg
trace ?i
nop
exit
