/*  Subject line Edit Script for PMMail - Copyright 1997, John & Chris Angelico  */
/*   to trim out Re: and Fwd: for sorting/storing by threads                     */
/*  Put this into the PMMAIL directory and use the Utilities Settings REXX tab   */
/*     to invoke this as a Message Receive Exit                                  */
/*  This uses only standard REXX Functions available with Warp 3 or 4            */
/*                                                                               */
/*  Released to the PMMail community for the benefit of all                      */
/*  Take it as it is. Do what you like with it.                                  */
/*  But don't blame us if it does any damage!!                                   */

Parse Arg targetfile
signal on syntax
Call Loadutils
trace i
CALL SYSFILESEARCH "Subject:", targetfile, BARE
/*
     Finds the text in the message file, if it exists
	We only want to find it in a Subject line, not in the body 
           and it has to be at the beginning of the line
*/

CALL SYSFILESEARCH "Subject:", targetfile, linecount, N 
/*     Finds the text in the file again, store the line number(s) this time. */

if bare.0 = 0 then signal egress  /* No Subject line & nothing to do  */

/* Otherwise we have found something so start searching for Re: & (Fwd)  */

/*  First trim multiple spaces from the line  */ 
bare.1 = space(bare.1)
remove=9

trim:
trimmed="Subject: "||RIGHT(BARE.1,LENGTH(BARE.1)-remove)

/* Now test to see if there is another Re: or (Fwd) in the line and loop back to trim it, too    */
if abbrev(translate(trimmed), "SUBJECT: RE:") then do; bare.1 = trimmed; remove = 13; signal trim; end 
if abbrev(translate(trimmed), "SUBJECT: FWD:") then do; bare.1 = trimmed; remove = 14; signal trim; end
if abbrev(translate(trimmed), "SUBJECT: (FWD)") then do; bare.1 = trimmed; remove = 15; signal trim; end
if abbrev(translate(trimmed), "SUBJECT: [FWD]") then do; bare.1 = trimmed; remove = 15; signal trim; end
if abbrev(translate(trimmed), "SUBJECT: FW:") then do; bare.1 = trimmed; remove = 13; signal trim; end


/* OK found every(?) occurrence, now write the trimmed line back to the message file */
position=word(linecount.1,1)-2
call linein targetfile,,1
do position
	call linein targetfile
end
CALL LINEOUT targetfile,trimmed
	 /*  we only have to do this once    */


egress:
/*  Make sure that the message is closed before we exit.                       */
rc = LineOut(targetfile)
return

CLEANUP:
	Say 'Findline.CMD interrupted!!'
	Call QuitIt
return

LoadUtils:
/* Load the REXXUtil functions                                                 */
CALL RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
CALL SysLoadFuncs
Return

QuitIt:
/* Close up and shut down   */
Return

exit

syntax:
call trace o
msg="Error "rc" - "errortext(rc)
say msg
call lineout "c:\desktop\errs.log",msg
msg="Line "sigl" - "sourceline(sigl)
say msg
call lineout "c:\desktop\errs.log",msg
trace ?i
nop
exit
